diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_set.c ircd-hybrid-6.0/src/m_set.c
--- ircd-hybrid-6.0.orig/src/m_set.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/m_set.c	Tue Jun 19 16:48:12 2001
@@ -207,8 +207,8 @@
                   return 0;
                 }
               MAXCLIENTS = new_value;
-              sendto_realops("%s!%s@%s set new MAXCLIENTS to %d (%d current)",
-                             parv[0], sptr->username, sptr->host, MAXCLIENTS, Count.local);
+              sendto_ops_flag(UMODE_SERVNOTICE, "%s!%s@%s set new MAXCLIENTS to %d (%d current)",
+				     parv[0], sptr->username, sptr->host, MAXCLIENTS, Count.local);
               return 0;
             }
           sendto_one(sptr, ":%s NOTICE %s :Current Maxclients = %d (%d)",
@@ -223,9 +223,9 @@
 
               if(!irccmp(parv[2],"ALL"))
                 {
-                  sendto_realops(
-                                 "%s has changed AUTOCONN ALL to %i",
-                                 parv[0], newval);
+                  sendto_ops_flag(UMODE_SERVNOTICE,
+					 "%s has changed AUTOCONN ALL to %i",
+					 parv[0], newval);
                   GlobalSetOptions.autoconn = newval;
                 }
               else
@@ -246,14 +246,14 @@
                 int newval = atoi(parv[2]);
                 if(newval == 0)
                   {
-                    sendto_realops("%s has disabled IDLE_CHECK",
-                                   parv[0]);
+                    sendto_ops_flag(UMODE_SERVNOTICE, "%s has disabled IDLE_CHECK",
+					   parv[0]);
                     IDLETIME = 0;
                   }
                 else
                   {
-                    sendto_realops("%s has changed IDLETIME to %i",
-                                   parv[0], newval);
+                    sendto_ops_flag(UMODE_SERVNOTICE, "%s has changed IDLETIME to %i",
+					   parv[0], newval);
                     IDLETIME = (newval*60);
                   }
               }
@@ -281,8 +281,8 @@
 #ifdef DEATHFLUD
                 if (FLUDNUM >= KILLNUM) KILLNUM = FLUDNUM + 2;
 #endif
-                sendto_realops("%s has changed FLUDNUM to %i",
-                               parv[0], FLUDNUM);
+                sendto_ops_flag(UMODE_SERVNOTICE, "%s has changed FLUDNUM to %i",
+				       parv[0], FLUDNUM);
               }
             else
               {
@@ -304,8 +304,8 @@
                     return 0;
                   }       
                 FLUDTIME = newval;
-                sendto_realops("%s has changed FLUDTIME to %i",
-                               parv[0], FLUDTIME);
+                sendto_ops_flag(UMODE_SERVNOTICE, "%s has changed FLUDTIME to %i",
+				       parv[0], FLUDTIME);
               }
             else
               {
@@ -329,13 +329,13 @@
                 FLUDBLOCK = newval;
                 if(FLUDBLOCK == 0)
                   {
-                    sendto_realops("%s has disabled flud detection/protection",
-                                   parv[0]);
+                    sendto_ops_flag(UMODE_SERVNOTICE, "%s has disabled flud detection/protection",
+					   parv[0]);
                   }
                 else
                   {
-                    sendto_realops("%s has changed FLUDBLOCK to %i",
-                                   parv[0],FLUDBLOCK);
+                    sendto_ops_flag(UMODE_SERVNOTICE, "%s has changed FLUDBLOCK to %i",
+					   parv[0],FLUDBLOCK);
                   }
               }
             else
@@ -359,8 +359,8 @@
                     return 0;
                   }       
                 KILLNUM = newval;
-                sendto_realops("%s has changed KILLNUM to %i, fear",
-                               parv[0], KILLNUM);
+                sendto_ops_flag(UMODE_SERVNOTICE, "%s has changed KILLNUM to %i, fear",
+				       parv[0], KILLNUM);
               }
             else
               {
@@ -386,11 +386,11 @@
                   }       
                 DRONETIME = newval;
                 if(DRONETIME == 0)
-                  sendto_realops("%s has disabled the ANTI_DRONE_FLOOD code",
+                  sendto_ops_flag(UMODE_SERVNOTICE, "%s has disabled the ANTI_DRONE_FLOOD code",
                                  parv[0]);
                 else
-                  sendto_realops("%s has changed DRONETIME to %i",
-                                 parv[0], DRONETIME);
+                  sendto_ops_flag(UMODE_SERVNOTICE, "%s has changed DRONETIME to %i",
+					 parv[0], DRONETIME);
               }
             else
               {
@@ -412,8 +412,8 @@
                   return 0;
                 }       
               DRONECOUNT = newval;
-              sendto_realops("%s has changed DRONECOUNT to %i",
-                             parv[0], DRONECOUNT);
+              sendto_ops_flag(UMODE_SERVNOTICE, "%s has changed DRONECOUNT to %i",
+				     parv[0], DRONECOUNT);
             }
           else
             {
@@ -444,7 +444,7 @@
                                  me.name, parv[0], MAX_SERVER_SPLIT_RECOVERY_TIME);
                       newval = MAX_SERVER_SPLIT_RECOVERY_TIME;
                     }
-                  sendto_realops("%s has changed SPLITDELAY to %i",
+                  sendto_ops_flag(UMODE_SERVNOTICE, "%s has changed SPLITDELAY to %i",
                                  parv[0], newval);
                   SPLITDELAY = (newval*60);
                   if(SPLITDELAY == 0)
@@ -484,7 +484,7 @@
                              me.name, parv[0],SPLIT_SMALLNET_SIZE);
                   return 0;
                 } */
-              sendto_realops("%s has changed SPLITNUM to %i",
+              sendto_ops_flag(UMODE_SERVNOTICE, "%s has changed SPLITNUM to %i",
                              parv[0], newval);
               SPLITNUM = newval;
             }
@@ -509,7 +509,7 @@
                                me.name, parv[0]);
                     return 0;
                   }
-                sendto_realops("%s has changed SPLITUSERS to %i",
+                sendto_ops_flag(UMODE_SERVNOTICE,"%s has changed SPLITUSERS to %i",
                                parv[0], newval);
                 SPLITUSERS = newval;
               }
@@ -537,7 +537,7 @@
                   }
                 if(newval == 0)
                   {
-                    sendto_realops("%s has disabled ANTI_SPAMBOT",
+                    sendto_ops_flag(UMODE_SERVNOTICE,"%s has disabled ANTI_SPAMBOT",
                                    parv[0]);
                     return 0;
                   }
@@ -546,7 +546,7 @@
                   SPAMNUM = MIN_SPAM_NUM;
                 else
                   SPAMNUM = newval;
-                sendto_realops("%s has changed SPAMNUM to %i",
+                sendto_ops_flag(UMODE_SERVNOTICE,"%s has changed SPAMNUM to %i",
                                parv[0], SPAMNUM);
               }
             else
@@ -573,7 +573,7 @@
                 SPAMTIME = MIN_SPAM_TIME;
               else
                 SPAMTIME = newval;
-              sendto_realops("%s has changed SPAMTIME to %i",
+              sendto_ops_flag(UMODE_SERVNOTICE,"%s has changed SPAMTIME to %i",
                              parv[0], SPAMTIME);
             }
           else
@@ -600,7 +600,7 @@
                 newval = L_DEBUG;
               set_log_level(newval); 
               log_level_as_string = get_log_level_as_string(newval);
-              sendto_realops("%s has changed LOG level to %i (%s)",
+              sendto_ops_flag(UMODE_SERVNOTICE,"%s has changed LOG level to %i (%s)",
                              parv[0], newval, log_level_as_string);
             }
           else
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_squit.c ircd-hybrid-6.0/src/m_squit.c
--- ircd-hybrid-6.0.orig/src/m_squit.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/m_squit.c	Tue Jun 19 16:48:26 2001
@@ -224,14 +224,14 @@
   */
   if (MyConnect(acptr) && IsServer(cptr))
     {
-      sendto_ops_flag_butone(NULL, UMODE_SERVNOTICE,
+      sendto_ops_flag(UMODE_SERVNOTICE,
 			     "%s received SQUIT %s from %s (%s)",
 			     me.name, server, get_client_name(sptr,FALSE), comment);
       log(L_TRACE, "SQUIT From %s : %s (%s)", parv[0], server, comment);
     }
   else if (MyConnect(acptr))
-    sendto_ops("Received SQUIT %s from %s (%s)",
-               acptr->name, get_client_name(sptr,FALSE), comment);
+    sendto_ops_flag(UMODE_SERVNOTICE, "Received SQUIT %s from %s (%s)",
+			   acptr->name, get_client_name(sptr,FALSE), comment);
   
   return exit_client(cptr, acptr, sptr, comment);
 }
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_stats.c ircd-hybrid-6.0/src/m_stats.c
--- ircd-hybrid-6.0.orig/src/m_stats.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/m_stats.c	Tue Jun 19 16:49:08 2001
@@ -518,7 +518,7 @@
     {
       if ( (stat == 'L') || (stat == 'l') )
         {
-          sendto_realops_flag(UMODE_SPY,
+          sendto_ops_flag(UMODE_SPY,
 			      "STATS %c requested by %s (%s@%s) [%s] on %s%s",
 			      stat,
 			      sptr->name,
@@ -531,7 +531,7 @@
         }
       else
         {
-          sendto_realops_flag(UMODE_SPY,
+          sendto_ops_flag(UMODE_SPY,
 			      "STATS %c requested by %s (%s@%s) [%s]%s",
 			      stat,
 			      sptr->name,
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_svinfo.c ircd-hybrid-6.0/src/m_svinfo.c
--- ircd-hybrid-6.0.orig/src/m_svinfo.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/m_svinfo.c	Tue Jun 19 16:48:30 2001
@@ -117,8 +117,8 @@
        * TS_ONLY we can't fall back to the non-TS protocol so
        * we drop the link  -orabidoo
        */
-      sendto_realops("Link %s dropped, wrong TS protocol version (%s,%s)",
-                 get_client_name(sptr, FALSE), parv[1], parv[2]);
+      sendto_ops_flag(UMODE_SERVNOTICE, "Link %s dropped, wrong TS protocol version (%s,%s)",
+			     get_client_name(sptr, FALSE), parv[1], parv[2]);
       return exit_client(sptr, sptr, sptr, "Incompatible TS version");
     }
 
@@ -131,17 +131,17 @@
 
   if (deltat > TS_MAX_DELTA)
     {
-      sendto_realops(
-       "Link %s dropped, excessive TS delta (my TS=%d, their TS=%d, delta=%d)",
-                 get_client_name(sptr, FALSE), CurrentTime, theirtime,deltat);
+      sendto_ops_flag(UMODE_SERVNOTICE, 
+			     "Link %s dropped, excessive TS delta (my TS=%d, their TS=%d, delta=%d)",
+			     get_client_name(sptr, FALSE), CurrentTime, theirtime,deltat);
       return exit_client(sptr, sptr, sptr, "Excessive TS delta");
     }
 
   if (deltat > TS_WARN_DELTA)
     { 
-      sendto_realops(
-                 "Link %s notable TS delta (my TS=%d, their TS=%d, delta=%d)",
-                 get_client_name(sptr, FALSE), CurrentTime, theirtime, deltat);
+      sendto_ops_flag(UMODE_SERVNOTICE, 
+			     "Link %s notable TS delta (my TS=%d, their TS=%d, delta=%d)",
+			     get_client_name(sptr, FALSE), CurrentTime, theirtime, deltat);
     }
 
   return 0;
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_trace.c ircd-hybrid-6.0/src/m_trace.c
--- ircd-hybrid-6.0.orig/src/m_trace.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/m_trace.c	Tue Jun 19 16:48:36 2001
@@ -181,9 +181,9 @@
     }
 
   if(MyClient(sptr))
-    sendto_realops_flag(UMODE_SPY, "trace requested by %s (%s@%s) [%s]",
-			sptr->name, sptr->username, sptr->host,
-			sptr->user->server);
+    sendto_ops_flag(UMODE_SPY, "trace requested by %s (%s@%s) [%s]",
+			   sptr->name, sptr->username, sptr->host,
+			   sptr->user->server);
 
 
   doall = (parv[1] && (parc > 1)) ? match(tname, me.name): TRUE;
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_unkline.c ircd-hybrid-6.0/src/m_unkline.c
--- ircd-hybrid-6.0.orig/src/m_unkline.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/m_unkline.c	Tue Jun 19 16:48:40 2001
@@ -144,8 +144,8 @@
       if (!IsServer(cptr))
         sendto_one(sptr, ":%s NOTICE %s :Un-klined [%s@%s] from temporary k-lines",
                    me.name, parv[0],user, host);
-      sendto_ops("%s has removed the temporary K-Line for: [%s@%s]",
-                 parv[0], user, host );
+      sendto_ops_flag(UMODE_SERVNOTICE, "%s has removed the temporary K-Line for: [%s@%s]",
+			     parv[0], user, host );
 
       log(L_NOTICE, "%s removed temporary K-Line for [%s@%s]",
           parv[0], user, host);
@@ -340,8 +340,8 @@
   if (!IsServer(cptr))
     sendto_one(sptr, ":%s NOTICE %s :K-Line for [%s@%s] is removed", 
              me.name, parv[0], user,host);
-  sendto_realops("%s has removed the K-Line for: [%s@%s]",
-             parv[0], user, host);
+  sendto_ops_flag(UMODE_SERVNOTICE, "%s has removed the K-Line for: [%s@%s]",
+			 parv[0], user, host);
 
   log(L_NOTICE, "%s removed K-Line for [%s@%s]", parv[0], user, host);
   return 0; 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_wallops.c ircd-hybrid-6.0/src/m_wallops.c
--- ircd-hybrid-6.0.orig/src/m_wallops.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/m_wallops.c	Wed Jun 20 02:24:39 2001
@@ -99,9 +99,15 @@
 { 
   char* message;
   int flag=0;
+  int spoof = 0;
 
   if (parc == 3)
     {
+      if (*parv[1] == '*')
+	{
+	  parv[1]++;
+	  spoof = 1;
+	}
       flag = atoi(parv[1]);
       message = parv[2];
     }
@@ -129,7 +135,10 @@
 
   if (parc == 3)
     {
-      sendto_ops_flag_butone(cptr, flag, "%s", message);
+      if (spoof)
+	sendto_ops_flag_butone_hidefrom(cptr, flag, "%s", message);
+      else
+	sendto_ops_flag_butone_from(cptr, flag, sptr, "%s", message);
       return 0;
     }
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/motd.c ircd-hybrid-6.0/src/motd.c
--- ircd-hybrid-6.0.orig/src/motd.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/motd.c	Tue Jun 19 16:48:47 2001
@@ -67,7 +67,7 @@
   if (hunt_server(cptr, sptr, ":%s MOTD :%s", 1,parc,parv)!=HUNTED_ISME)
     return 0;
 
-  sendto_realops_flag(UMODE_SPY, "motd requested by %s (%s@%s) [%s]",
+  sendto_ops_flag(UMODE_SPY, "motd requested by %s (%s@%s) [%s]",
 		      sptr->name, sptr->username, sptr->host,
 		      sptr->user->server);
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/mtrie_conf.c ircd-hybrid-6.0/src/mtrie_conf.c
--- ircd-hybrid-6.0.orig/src/mtrie_conf.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/mtrie_conf.c	Tue Jun 19 16:48:52 2001
@@ -321,7 +321,7 @@
     }
   else
     {
-      sendto_realops("Bug: in find_or_add_host_piece. yay.");
+      sendto_ops_flag(UMODE_DEBUG, "BUG: in find_or_add_host_piece. yay.");
       return(NULL);
     }
   /* NOT REACHED */
@@ -483,7 +483,7 @@
     {
       /*
        */
-      sendto_realops("Bug in mtrie_conf.c last_ptr found NULL");
+      sendto_ops_flag(UMODE_DEBUG, "BUG: in mtrie_conf.c last_ptr found NULL");
     }
 
   return;
@@ -1740,6 +1740,6 @@
 
   get_printable_conf(aconf, &name, &host, &pass, &user, &port);
 
-  sendto_realops("DUP: %c: (%s@%s) pass %s name %s port %d",
-                 type,user,host,pass,name,port);
+  sendto_ops_flag(UMODE_SERVNOTICE, "DUP: %c: (%s@%s) pass %s name %s port %d",
+			 type,user,host,/*pass*/"",name,port); /* Uhh... let's not broadcast passwords. Thankyou. -- asuffield */
 }
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/oratime.c ircd-hybrid-6.0/src/oratime.c
--- ircd-hybrid-6.0.orig/src/oratime.c	Sat Nov 18 19:11:13 2000
+++ ircd-hybrid-6.0/src/oratime.c	Tue Jun 19 16:48:56 2001
@@ -61,7 +61,7 @@
 
 void orat_report(void)
 {
-  sendto_realops("Time spent: %ld ms", tsdms);
+  sendto_ops_flag(UMODE_DEBUG, "Time spent: %ld ms", tsdms);
 }
 
 #endif /* ORATIMING */
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/parse.c ircd-hybrid-6.0/src/parse.c
--- ircd-hybrid-6.0.orig/src/parse.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/parse.c	Tue Jun 19 16:49:15 2001
@@ -520,19 +520,19 @@
    */
   if (IsServer(sptr) || IsMe(sptr))
     {
-      sendto_realops_flag(UMODE_SERVNOTICE, "Message for %s[%s] from %s",
+      sendto_ops_flag(UMODE_SERVNOTICE, "Message for %s[%s] from %s",
 			  sptr->name, sptr->from->name,
 			  get_client_name(cptr, TRUE));
       if (IsServer(cptr))
         {
-          sendto_realops_flag(UMODE_SERVNOTICE,
+          sendto_ops_flag(UMODE_SERVNOTICE,
 			      "Not dropping server %s (%s) for Fake Direction",
 			      cptr->name, sptr->name);
           return -1;
         }
 
       if (IsClient(cptr))
-        sendto_realops_flag(UMODE_SERVNOTICE,
+        sendto_ops_flag(UMODE_SERVNOTICE,
 			    "Would have dropped client %s (%s@%s) [%s from %s]",
 			    cptr->name, cptr->username, cptr->host,
 			    cptr->user->server, cptr->from->name);
@@ -556,7 +556,7 @@
     if (DoesTS(cptr))
       {
         if (sptr->user)
-          sendto_realops_flag(UMODE_DEBUG,
+          sendto_ops_flag(UMODE_DEBUG,
 			      "Message for %s[%s@%s!%s] from %s (TS, ignored)",
 			      sptr->name, sptr->username, sptr->host,
 			      sptr->from->name, get_client_name(cptr, TRUE));
@@ -566,7 +566,7 @@
       {
         if (sptr->user)
           {
-            sendto_realops_flag(UMODE_DEBUG,
+            sendto_ops_flag(UMODE_DEBUG,
 				"Message for %s[%s@%s!%s] from %s",
 				sptr->name, sptr->username, sptr->host,
 				sptr->from->name, get_client_name(cptr, TRUE));
@@ -592,7 +592,7 @@
 
   if (IsClient(cptr))
     {
-      sendto_realops_flag(UMODE_DEBUG,
+      sendto_ops_flag(UMODE_DEBUG,
 			  "Weirdness: Unknown client prefix (%s) from %s, Ignoring %s",
 			  buffer,
 			  get_client_name(cptr, FALSE), sender);
@@ -615,8 +615,8 @@
                get_client_name(cptr, FALSE));
   else
     {
-      sendto_realops_flag(UMODE_DEBUG,
-			  "Unknown prefix (%s) from %s, Squitting %s", buffer, get_client_name(cptr, FALSE), sender);
+      sendto_ops_flag(UMODE_DEBUG,
+			     "Unknown prefix (%s) from %s, Squitting %s", buffer, get_client_name(cptr, FALSE), sender);
       sendto_one(cptr, ":%s SQUIT %s :(Unknown prefix (%s) from %s)",
                  me.name, sender, buffer, get_client_name(cptr, FALSE));
     }
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/restart.c ircd-hybrid-6.0/src/restart.c
--- ircd-hybrid-6.0.orig/src/restart.c	Wed Jun 20 03:42:13 2001
+++ ircd-hybrid-6.0/src/restart.c	Tue Jun 19 20:01:00 2001
@@ -10,6 +10,7 @@
 #include "struct.h"
 #include "s_debug.h"
 #include "s_log.h"
+#include "client.h"
 
 #include <unistd.h>
 
@@ -34,7 +35,7 @@
 {
   int i;
   
-  sendto_ops("Aieeeee!!!  Restarting server... memory: %d", get_maxrss());
+  sendto_ops_flag(UMODE_SERVNOTICE, "Aieeeee!!!  Restarting server... memory: %d", get_maxrss());
 
   log(L_NOTICE, "Restarting server...");
   flush_connections(0);
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_auth.c ircd-hybrid-6.0/src/s_auth.c
--- ircd-hybrid-6.0.orig/src/s_auth.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/s_auth.c	Tue Jun 19 16:49:24 2001
@@ -258,8 +258,8 @@
     return 0;
   }
   if ((MAXCONNECTIONS - 10) < fd) {
-    sendto_realops("Can't allocate fd for auth on %s",
-                get_client_name(auth->client, FALSE));
+    sendto_ops_flag(UMODE_SERVNOTICE, "Can't allocate fd for auth on %s",
+			   get_client_name(auth->client, FALSE));
 
     close(fd);
     return 0;
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_bsd.c ircd-hybrid-6.0/src/s_bsd.c
--- ircd-hybrid-6.0.orig/src/s_bsd.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/s_bsd.c	Tue Jun 19 16:49:29 2001
@@ -171,7 +171,7 @@
 {
   who = (who) ? who : "";
 
-  sendto_realops_flag(UMODE_DEBUG, text, who, strerror(error));
+  sendto_ops_flag(UMODE_DEBUG, text, who, strerror(error));
 
   log(L_ERROR, text, who, strerror(error));
 }
@@ -191,7 +191,7 @@
     connect_server(aconf, 0, reply);
   }
   else
-    sendto_realops("Connect to %s failed: host lookup", aconf->host);
+    sendto_ops_flag(UMODE_SERVNOTICE, "Connect to %s failed: host lookup", aconf->host);
 }
 
 /*
@@ -364,13 +364,13 @@
   c_conf = find_conf_name(cptr->confs, cptr->name, CONF_CONNECT_SERVER);
   if (!c_conf)
     {
-      sendto_realops("Lost C-Line for %s", get_client_name(cptr,FALSE));
+      sendto_ops_flag(UMODE_SERVNOTICE, "Lost C-Line for %s", get_client_name(cptr,FALSE));
       return 0;
     }
   n_conf = find_conf_name(cptr->confs, cptr->name, CONF_NOCONNECT_SERVER);
   if (!n_conf)
     {
-      sendto_realops("Lost N-Line for %s", get_client_name(cptr,FALSE));
+      sendto_ops_flag(UMODE_SERVNOTICE, "Lost N-Line for %s", get_client_name(cptr,FALSE));
       return 0;
     }
   
@@ -413,7 +413,7 @@
 
   if (cptr->fd >= (HARD_FDLIMIT - 10))
     {
-      sendto_realops("No more connections allowed (%s)", cptr->name);
+      sendto_ops_flag(UMODE_SERVNOTICE,"No more connections allowed (%s)", cptr->name);
       return 0;
     }
 
@@ -507,7 +507,7 @@
    */
   if ((cptr = find_server(aconf->name)))
     {
-      sendto_realops("Server %s already present from %s",
+      sendto_ops_flag(UMODE_SERVNOTICE,"Server %s already present from %s",
                  aconf->name, get_client_name(cptr, FALSE));
       if (by && IsPerson(by) && !MyClient(by))
         sendto_one(by, ":%s NOTICE %s :Server %s already present from %s",
@@ -568,7 +568,7 @@
    */
   if (!attach_cn_lines(cptr, aconf->host))
     {
-      sendto_realops("Host %s is not enabled for connecting:no C/N-line",
+      sendto_ops_flag(UMODE_SERVNOTICE,"Host %s is not enabled for connecting:no C/N-line",
                  aconf->host);
       if (by && IsPerson(by) && !MyClient(by))
         sendto_one(by, ":%s NOTICE %s :Connect to host %s failed.",
@@ -922,16 +922,16 @@
       int connected = CurrentTime - cptr->firsttime;
       
       if (0 == error)
-        sendto_ops("Server %s closed the connection",
-                   get_client_name(cptr, MASK_IP));
+        sendto_ops_flag(UMODE_SERVNOTICE, "Server %s closed the connection",
+			       get_client_name(cptr, MASK_IP));
       else
         report_error("Lost connection to %s:%s", 
                      get_client_name(cptr, MASK_IP), current_error);
-      sendto_realops("%s had been connected for %d day%s, %2d:%02d:%02d",
-                 cptr->name, connected/86400,
-                 (connected/86400 == 1) ? "" : "s",
-                 (connected % 86400) / 3600, (connected % 3600) / 60,
-                 connected % 60);
+      sendto_ops_flag(UMODE_SERVNOTICE,"%s had been connected for %d day%s, %2d:%02d:%02d",
+			     cptr->name, connected/86400,
+			     (connected/86400 == 1) ? "" : "s",
+			     (connected % 86400) / 3600, (connected % 3600) / 60,
+			     connected % 60);
     }
   if (0 == error)
     strcpy(errmsg, "Remote closed the connection");
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_conf.c ircd-hybrid-6.0/src/s_conf.c
--- ircd-hybrid-6.0.orig/src/s_conf.c	Wed Jun 20 03:42:17 2001
+++ ircd-hybrid-6.0/src/s_conf.c	Wed Jun 20 00:16:13 2001
@@ -458,15 +458,15 @@
               /* abuse it, lose it. */
 #ifdef SPOOF_FREEFORM
 #ifdef SPOOF_NOTICE
-              sendto_realops("%s spoofing: %s(%s) as %s", cptr->name,
-                             cptr->host, inetntoa((char*) &cptr->ip), aconf->name);
+              sendto_ops_flag(UMODE_CCONN, "%s spoofing: %s(%s) as %s", cptr->name,
+				     cptr->host, inetntoa((char*) &cptr->ip), aconf->name);
 #endif /* SPOOF_NOTICE */
               strncpy_irc(cptr->host, aconf->name, HOSTLEN);
 #else
               /* default to oper.server.name.tld */
 #ifdef SPOOF_NOTICE
-              sendto_realops("%s spoofing: %s(%s) as oper.%s", cptr->name,
-                             cptr->host, inetntoa((char*) &cptr->ip), me.name);
+              sendto_ops_flag_butonr(NULL, UMODE_CCONN, "%s spoofing: %s(%s) as oper.%s", cptr->name,
+				     cptr->host, inetntoa((char*) &cptr->ip), me.name);
 #endif /* SPOOF_NOTICE */
               strcpy(cptr->host, "oper.");
               strncpy_irc(&cptr->host[5], me.name, HOSTLEN - 5);
@@ -649,8 +649,8 @@
     {
       if( free_ip_entries == (IP_ENTRY *)NULL)
         {
-          sendto_realops("s_conf.c free_ip_entries was found NULL in find_or_add");
-          sendto_realops("Please report to the hybrid team! ircd-hybrid@the-project.org");
+          sendto_ops_flag(UMODE_DEBUG,"s_conf.c free_ip_entries was found NULL in find_or_add");
+          sendto_ops_flag(UMODE_DEBUG,"Please report to the dancer-hybrid team! opn-coders@vc.bc.ca");
           outofmemory();
         }
 
@@ -673,8 +673,8 @@
     {
       if( free_ip_entries == (IP_ENTRY *)NULL)
         {
-          sendto_realops("s_conf.c free_ip_entries was found NULL in find_or_add");
-          sendto_realops("Please report to the hybrid team! ircd-hybrid@the-project.org");
+          sendto_ops_flag(UMODE_DEBUG,"s_conf.c free_ip_entries was found NULL in find_or_add");
+          sendto_ops_flag(UMODE_DEBUG,"Please report to the dancer-hybrid team! opn-coders@vc.bc.ca");
           outofmemory();
         }
 
@@ -807,8 +807,8 @@
           ptr = ptr->next;
         }
     }
-  sendto_realops("s_conf.c couldn't find ip# in hash table in remove_one_ip()");
-  sendto_realops("Please report to the hybrid team! ircd-hybrid@the-project.org");
+  sendto_ops_flag(UMODE_DEBUG,"s_conf.c couldn't find ip# in hash table in remove_one_ip()");
+  sendto_ops_flag(UMODE_DEBUG,"Please report to the dancer-hybrid team! opn-coders@vc.bc.ca");
   return;
 }
 
@@ -1140,13 +1140,14 @@
   assert(0 != cptr);
   assert(0 != host);
 
+  log(L_NOTICE, "Connection from %s claiming to be %s", host, cptr->name);
   for (tmp = ConfigItemList; tmp; tmp = tmp->next) {
     if (!IsIllegal(tmp)) {
       /*
        * look for matching C:line
        */
       if (!found_cline && CONF_CONNECT_SERVER == tmp->status && 
-          tmp->host && 0 == irccmp(tmp->host, host)) {
+          tmp->host && (0 == irccmp(tmp->host, host)) && (irccmp(tmp->name, cptr->name) == 0)) {
         attach_conf(cptr, tmp);
         if (found_nline)
           return 1;
@@ -1156,7 +1157,7 @@
        * look for matching N:line
        */
       else if (!found_nline && CONF_NOCONNECT_SERVER == tmp->status &&
-               tmp->host && 0 == irccmp(tmp->host, host)) {
+               tmp->host && 0 == irccmp(tmp->host, host) && (irccmp(tmp->name, cptr->name) == 0)) {
         attach_conf(cptr, tmp);
         if (found_cline)
           return 1;
@@ -1727,7 +1728,7 @@
 int rehash(aClient *cptr,aClient *sptr, int sig)
 {
   if (sig)
-    sendto_realops("Got signal SIGHUP, reloading ircd conf. file");
+    sendto_ops_flag(UMODE_SERVNOTICE,"Got signal SIGHUP, reloading ircd conf. file");
 
   read_conf_files(NO);
   close_listeners();
@@ -2117,7 +2118,7 @@
 
               if(classToFind && (ClassPtr(aconf) == class0))
                 {
-                  sendto_realops(
+                  sendto_ops_flag(UMODE_SERVNOTICE,
                            "Warning *** Defaulting to class 0 for class %d",
                          classToFind);
                 }
@@ -2157,7 +2158,7 @@
 
 	      if(ps || pt)
 		{
-		  sendto_realops("H: or L: line trailing whitespace [%s]",
+		  sendto_ops_flag(UMODE_SERVNOTICE,"H: or L: line trailing whitespace [%s]",
 				 aconf->user);
 		  if(ps)*ps = '\0';
 		  if(pt)*pt = '\0';
@@ -2260,19 +2261,19 @@
           if (ncount > MAXCONFLINKS || ccount > MAXCONFLINKS ||
               !aconf->host || !aconf->user)
             {
-              sendto_realops("Bad C/N line");
+              sendto_ops_flag(UMODE_SERVNOTICE,"Bad C/N line");
               continue;
             }
 
           if (BadPtr(aconf->passwd))
             {
-              sendto_realops("Bad C/N line host %s", aconf->host);
+              sendto_ops_flag(UMODE_SERVNOTICE,"Bad C/N line host %s", aconf->host);
               continue;
             }
           
           if( SplitUserHost(aconf) < 0 )
             {
-              sendto_realops("Bad C/N line host %s", aconf->host);
+              sendto_ops_flag(UMODE_SERVNOTICE,"Bad C/N line host %s", aconf->host);
               free_conf(aconf);
               aconf = NULL;
               continue;
@@ -2287,7 +2288,7 @@
         {
           if(SplitUserHost(aconf) < 0)
             {
-              sendto_realops("Bad O/o line host %s", aconf->host);
+              sendto_ops_flag(UMODE_SERVNOTICE,"Bad O/o line host %s", aconf->host);
               free_conf(aconf);
               aconf = NULL;
 	      continue;
@@ -2578,10 +2579,10 @@
     {
       nextinclude = include_list->next;
       if ((file = openconf(include_list->name)) == 0)
-        sendto_realops("Can't open %s include file",include_list->name);
+        sendto_ops_flag(UMODE_SERVNOTICE,"Can't open %s include file",include_list->name);
       else
         {
-          sendto_realops_flag(UMODE_DEBUG, "Hashing in %s include file",include_list->name);
+          sendto_ops_flag(UMODE_DEBUG, "Hashing in %s include file",include_list->name);
           initconf(file, NO);
         }
       free_conf(include_list);
@@ -3311,7 +3312,7 @@
         }
       else
         {
-          sendto_realops("Can't open %s file aborting rehash!", filename );
+          sendto_ops_flag(UMODE_SERVNOTICE,"Can't open %s file aborting rehash!", filename );
           return;
         }
     }
@@ -3339,7 +3340,7 @@
             }
           else
             {
-              sendto_realops("Can't open %s file klines could be missing!",
+              sendto_ops_flag(UMODE_SERVNOTICE,"Can't open %s file klines could be missing!",
                          kfilename);
             }
         }
@@ -3358,7 +3359,7 @@
             }
           else
             {
-              sendto_realops("Can't open %s file dlines could be missing!",
+              sendto_ops_flag(UMODE_SERVNOTICE,"Can't open %s file dlines could be missing!",
                          dfilename);
             }
         }
@@ -3496,14 +3497,14 @@
     {
       if(type == DLINE_TYPE)
         {
-          sendto_realops("%s added D-Line for [%s] [%s]",
+          sendto_ops_flag(UMODE_SERVNOTICE,"%s added D-Line for [%s] [%s]",
                          sptr->name, host, reason);
           sendto_one(sptr, ":%s NOTICE %s :Added D-Line [%s] to %s",
                      me.name, sptr->name, host, filename);
         }
       else
         {
-          sendto_realops("%s added K-Line for [%s@%s] [%s]",
+          sendto_ops_flag(UMODE_SERVNOTICE,"%s added K-Line for [%s@%s] [%s]",
                          sptr->name, user, host, reason);
           sendto_one(sptr, ":%s NOTICE %s :Added K-Line [%s@%s] to %s",
                      me.name, sptr->name, user, host, filename);
@@ -3512,7 +3513,7 @@
 
   if ((out = open(filename, O_RDWR|O_APPEND|O_CREAT,0644))==-1)
     {
-      sendto_realops("Problem opening %s ", filename);
+      sendto_ops_flag(UMODE_SERVNOTICE,"Problem opening %s ", filename);
       return;
     }
 
@@ -3588,7 +3589,7 @@
 {
   if (write(out, buffer, strlen(buffer)) <= 0)
     {
-      sendto_realops("*** Problem writing to %s",filename);
+      sendto_ops_flag(UMODE_SERVNOTICE,"*** Problem writing to %s",filename);
       close(out);
       return -1;
     }
